Imports System.IO.File
Imports System.IO.FileStream
Imports System.Runtime.InteropServices
Imports Microsoft.Win32.SafeHandles
Imports System.Net.Sockets
Imports tine

Public Class Form1
  Private Const PipePath = "\\.\pipe\"
  Public Const NMPWAIT_NOWAIT = 1
  Public Const NMPWAIT_USE_DEFAULT_WAIT = 0
  Public Const NMPWAIT_WAIT_FOREVER = -1

  Public Const FILE_FLAG_WRITE_THROUGH = &H80000000
  Public Const FILE_FLAG_OVERLAPPED = &H40000000
  Public Const FILE_FLAG_NO_BUFFERING = &H20000000
  Public Const FILE_FLAG_RANDOM_ACCESS = &H10000000
  Public Const FILE_FLAG_SEQUENTIAL_SCAN = &H8000000
  Public Const FILE_FLAG_DELETE_ON_CLOSE = &H4000000
  Public Const FILE_FLAG_BACKUP_SEMANTICS = &H2000000
  Public Const FILE_FLAG_POSIX_SEMANTICS = &H1000000

  Dim rwOverlapped As System.Threading.NativeOverlapped
  Dim rOverlapped As System.Threading.NativeOverlapped

  Dim pipeHandle As SafeFileHandle
  Dim hWriteEvent As Integer
  Dim hReadEvent As Integer

  Dim dbgClient As TcpClient
  Dim dbgStream As NetworkStream


  Dim sa As SECURITY_ATTRIBUTES
  Dim PipeName As String
  Dim pipePort As Integer
  Dim pipePortName As String

  Public Const FILE_SHARE_READ = &H1
  Public Const FILE_SHARE_WRITE = &H2
  Public Const OPEN_EXISTING = 3
  Public Const FILE_ATTRIBUTE_NORMAL = &H80
  Public Const GENERIC_READ = &H80000000
  Public Const GENERIC_WRITE = &H40000000
  Public Const GENERIC_EXECUTE = &H20000000
  Public Const GENERIC_ALL = &H10000000
  Dim cmdBuffer(99) As String
  Dim cmdBufferPtr As Integer
  Dim cmdScanPtr As Integer

  Dim fp As System.IO.FileStream
  Dim pipeReadBuffer As System.Text.StringBuilder
  Dim nullBuffer As System.Text.StringBuilder
  Dim pipeHasBeenRead As Boolean

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Dim fec As String
    Dim msg As String, inpt$
    fec = Command$()
    If Len(fec) = 0 Then
      inpt$ = "Enter the FEC Name (via local pipe - normal usage)" + vbNewLine
      inpt$ = inpt$ + "    e.g. SINEFEC.1 :" + vbNewLine
      inpt$ = inpt$ + "Or fully specified server name (via remote stream)" + vbNewLine
      inpt$ = inpt$ + "    e.g. /TEST/SineServer :"
      fec = InputBox(inpt$, "Attach to FEC")
      If Len(fec) = 0 Then
        msg = "Usage: attachfec <fecname>                  (via local pipe - normal usage)" + vbNewLine
        msg = msg + "       or: attachfec /<context>/<server>  (via remote stream)"
        MsgBox(msg, vbOKOnly, "Input Error")
        End
      End If
    End If

        Me.Text = fec + " Activity"
        pipeReadBuffer = New System.Text.StringBuilder(4096)
        pipeHandle = New SafeFileHandle(IntPtr.Zero, True)
    openServicePipe(fec)
    dbgButton.PerformClick()
  End Sub
  Sub openServicePipe(ByVal FecName As String)
    Dim res As Long
    'Dim ps As String
    Dim p As Integer

    Timer1.Enabled = True

    If FecName.StartsWith("/") Then
      Dim nms() As String
      nms = Split(FecName, "/")
      If UBound(nms) < 2 Then
        MsgBox(FecName + " is not of the form /<context>/<server>")
        Exit Sub
      End If
      Dim tsa As TServerAddress
      tsa = TQuery.GetServerAddress(nms(1), nms(2))
      If tsa Is Null Then
        MsgBox(FecName + " could not be resolved")
        Exit Sub
      End If
      pipePort = 10503 + tsa.GetPortOffset()
      dbgClient = New TcpClient(tsa.GetIpAddress().ToString, pipePort)
      dbgStream = dbgClient.GetStream()
      Exit Sub
    End If

    PipeName = PipePath + FecName + ".ipc"
    res = WaitNamedPipe(PipeName, NMPWAIT_USE_DEFAULT_WAIT)
    If res <> 0 Then Exit Sub

    pipePortName = "C:\tine\cache\" + FecName + ".ipc"
    On Error GoTo pipeError

    fp = Open(pipePortName, IO.FileMode.Open, IO.FileAccess.ReadWrite)
    Dim ps(64) As Byte, pschars() As Char
    Dim nread As Integer, i As Integer
    nread = fp.Read(ps, 0, 64)
    ReDim pschars(nread - 1)
    For i = 0 To nread - 1
      pschars(i) = CChar(CStr(Asc(ps(i))))
    Next
    pipePort = Val(New String(pschars))
    'CreateFile(pipePortName, )

    'Open pipePortName(1) For Input Access Read Shared As #1
    'Line Input #1, ps
    'Close #1
    'pipePort = Val(ps)
    'Winsock1.Connect(Winsock1.LocalHostName, pipePort)

    Exit Sub

pipeError:
    statusLabel.Text = "pipe: " + PipeName + " is not  available"
  End Sub
  Sub SendCmdToFec(ByVal cmdString As String)
    Dim nWritten As Integer, nRead As Integer, nAvail As Integer, n As Integer
    Dim res As SafeFileHandle, i As Integer
        'Dim cmdBytes() As Byte, cmdChars() As Char
    Dim cmdStr As System.Text.StringBuilder
    Dim retStr As String

    cmdStr = New System.Text.StringBuilder(cmdString)
    If pipePort <> 0 Then
      cmdString = cmdString + vbNewLine
      Dim data As [Byte]() = System.Text.Encoding.ASCII.GetBytes(cmdString)
      dbgStream.Write(data, 0, data.Length)
      Exit Sub
    End If
    If pipeHandle.IsInvalid Then
      sa.bInheritHandle = 0
      sa.lpSecurityDescriptor = 0
      sa.nLength = Len(sa)
      pipeHandle = CreateFile(PipeName, GENERIC_READ + GENERIC_WRITE, 0, IntPtr.Zero, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0)
      If pipeHandle.IsInvalid Then
        statusLabel.Text = "invalid pipeHandle " + Str(Marshal.GetLastWin32Error())
        Exit Sub
      Else
        statusLabel.Text = "pipeHandle = " + pipeHandle.ToString()
      End If
      hWriteEvent = CreateEvent(sa, True, False, vbNullString)
      hReadEvent = CreateEvent(sa, True, False, vbNullString)
    End If
    rwOverlapped.EventHandle = hWriteEvent
    n = Len(cmdString)
    res = WriteFile(pipeHandle, cmdStr, n, nWritten, rwOverlapped)
    If Not res.IsInvalid Then
      statusLabel.Text = "request = " + cmdString + " sent. Length of message = " + Str(nWritten)
    Else
      statusLabel.Text = "error sending request ! " + Str(Marshal.GetLastWin32Error())
      CloseHandle(pipeHandle)
      Exit Sub
    End If
    appendOutput(vbNewLine + ">" + cmdString + vbNewLine + ">")
    pipeHasBeenRead = True
    rOverlapped.EventHandle = hReadEvent
    Do
      n = 0
      PeekNamedPipe(pipeHandle, nullBuffer, 0, 0, nAvail, 0)
      If nAvail = 0 Then Exit Do
      If nAvail > 4095 Then nAvail = 4095
      pipeReadBuffer.Length = 0
      res = ReadFile(pipeHandle, pipeReadBuffer, nAvail, nRead, rOverlapped)
      retStr = pipeReadBuffer.ToString(0, nRead)
      If Not res.IsInvalid Then appendOutput(retStr) Else Exit Do
    Loop While nAvail > 0

  End Sub
  Private Sub appendOutput(ByVal msg As String)
    Dim txtlen As Long
    Dim maxlen As Integer

    On Error GoTo appendOutputError
    maxlen = 1000 'Val(scrBufferSizeText.text)
    If maxlen < 1000 Then maxlen = 1000
    If maxlen > 8000 Then maxlen = 8000 ' max text string length !
    maxlen = maxlen * 40 ' average 40 chars per line
    txtlen = Len(outputText.text)
    If txtlen > maxlen + Len(msg) Then
      outputText.Text = outputText.Text.Substring(2 * Len(msg))
    End If
    msg.Trim()
    'msg = TrimString(msg)
    outputText.AppendText(msg)
    outputText.ScrollToCaret()
    Exit Sub
appendOutputError:
    maxlen = 100
    Resume Next
  End Sub

  Private Sub sendCmd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles sendCmd.Click
    Static lastCmd As String
    SendCmdToFec(cmdText.Text)
    cmdScanPtr = cmdBufferPtr
    If cmdText.Text = lastCmd Then Exit Sub
    lastCmd = cmdText.Text
    cmdBuffer(cmdBufferPtr) = cmdText.Text
    cmdBufferPtr = (cmdBufferPtr + 1) Mod 100
  End Sub
  Dim dbgData = New [Byte](4096) {}
  Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
    Dim nRead As Integer, nAvail As Integer, n As Integer
    Dim res As SafeFileHandle
    Dim retStr As String

    Do
      n = 0
      If pipePort <> 0 Then
        If dbgStream.DataAvailable Then
          ' Read the first batch of the TcpServer response bytes. 
          nAvail = dbgStream.Read(dbgData, 0, dbgData.Length)
          retStr = System.Text.Encoding.ASCII.GetString(dbgData, 0, nAvail)
          appendOutput(retStr)
        Else
          nAvail = 0
        End If
      Else
        PeekNamedPipe(pipeHandle, nullBuffer, 0, 0, nAvail, 0)
        If nAvail = 0 Then Exit Do
        Debug.Print("timer sees " + Str(nAvail) + " bytes")
        If nAvail > 4095 Then nAvail = 4095
        pipeReadBuffer.Length = 0
        res = ReadFile(pipeHandle, pipeReadBuffer, nAvail, nRead, rOverlapped)
        retStr = pipeReadBuffer.ToString(0, nRead)
        If Not res.IsInvalid Then appendOutput(retStr) Else Exit Do
      End If
    Loop While nAvail > 0
  End Sub

  Private Sub dbgButton_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dbgButton.CheckedChanged
    If dbgButton.Checked Then
      SendCmdToFec("set debug=0")
    End If
  End Sub

  Private Sub dbg1Button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dbg1Button.CheckedChanged
    If dbg1Button.Checked Then
      SendCmdToFec("set debug=1")
    End If
  End Sub

  Private Sub dbg2Button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dbg2Button.CheckedChanged
    If dbg2Button.Checked Then
      SendCmdToFec("set debug=2")
    End If
  End Sub

  Private Sub dbg3Button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dbg3Button.CheckedChanged
    If dbg3Button.Checked Then
      SendCmdToFec("set debug=3")
    End If
  End Sub

  Private Sub dbg4Button_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dbg4Button.CheckedChanged
    If dbg4Button.Checked Then
      SendCmdToFec("set debug=4")
    End If
  End Sub

  Private Sub cmdHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdHelp.Click
    SendCmdToFec("help")
  End Sub

  Private Sub cmdClients_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClients.Click
    SendCmdToFec("get clients")
  End Sub

  Private Sub cmdContracts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdContracts.Click
    SendCmdToFec("get contracts")
  End Sub

  Private Sub cmdConnections_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdConnections.Click
    SendCmdToFec("get connections")
  End Sub

  Private Sub cmdStats_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStats.Click
    SendCmdToFec("get stats")
  End Sub

  Private Sub cmdModules_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdModules.Click
    SendCmdToFec("get modules")
  End Sub

  Private Sub cmdTime_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdTime.Click
    SendCmdToFec("get time")
  End Sub

  Private Sub cmdVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdVersion.Click
    SendCmdToFec("get version")
  End Sub

  Private Sub cmdSecurity_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSecurity.Click
    SendCmdToFec("get settings")
  End Sub

  Private Sub cmdText_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles cmdText.KeyDown
    If e.KeyCode = Keys.Return Then
      Static lastCmd As String
      SendCmdToFec(cmdText.Text)
      cmdScanPtr = cmdBufferPtr
      If cmdText.Text = lastCmd Then Exit Sub
      lastCmd = cmdText.Text
      cmdBuffer(cmdBufferPtr) = cmdText.Text
      cmdBufferPtr = (cmdBufferPtr + 1) Mod 100
    End If
  End Sub

  Private Sub cmdBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdBack.Click
    Dim p As Integer
    p = (cmdScanPtr + 99) Mod 100
    If Len(cmdBuffer(p)) > 0 Then
      cmdScanPtr = p
    End If
    cmdText.Text = cmdBuffer(cmdScanPtr)
  End Sub

  Private Sub cmdFwd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdFwd.Click
    Dim p As Integer
    p = (cmdScanPtr + 1) Mod 100
    If Len(cmdBuffer(p)) > 0 Then
      cmdScanPtr = p
    End If
    cmdText.Text = cmdBuffer(cmdScanPtr)
  End Sub

  Private Sub Form1_unload(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    If pipePort <> 0 Then
      dbgStream.Close()
      dbgClient.Close()
    End If
  End Sub
End Class
